#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
ll INF = 1e18;
struct Point{
    ll x, y;
    Point(ll a, ll b){
        x = a;
        y = b;
    }
    Point(Point a, Point b){
        x = b.x - a.x;
        y = b.y - a.y;
    }
    ld angle(){
        return atan2(y, x);
    }
    ld distance(){
        return hypot(abs(x), abs(y));
    }
};
int main() {
    ll n, t;
    cin >> n >> t;
    vector <Point> v;
    map <pair<ll, ll>, bool> dict;
    vector <char> ans(n, 'R');
    for(ll i = 0; i < n; i++){
        ll x, y;
        cin >> x >> y;
        v.push_back(Point(x, y));
    }
    for(ll i = 0; i < n; i++){
        for(ll j = 0; j < n; j++) {
            if (i == j)continue;
            if (dict.find({i, j}) != dict.end())continue;
            ll l = i, r = j;
            map<pair<ll, ll>, bool> local;
            local[{l, r}] = true;
            pair<ll, ll> circle;
            bool is_local = false;
           // cout << l << " " << r << endl;
            while (true) {
                Point vec = Point(v[l], v[r]);
                ld beg = vec.angle();
                vector<vector<ld>> mb;
                mb.push_back({beg, 0, -1});
                for (ll z = 0; z < n; z++) {
                    if (r == z)continue;
                    vec = Point(v[r], v[z]);
                    mb.push_back({vec.angle(), vec.distance(), (ld) z});
                }
                sort(mb.begin(), mb.end());
                //cout << l << " " << r << endl;
                //for(auto g : mb)cout << g[0] << " " << g[1] << " " << g[2] << endl;
                for (ll z = 0; z < n; z++) {
                    if (mb[z][2] == -1) {
                        l = r;
                        r = (ll) mb[(z + t) % n][2];
                        break;
                    }
                }
                //cout << l << " " << r << endl;
                if (dict.find({l, r}) != dict.end()) {
                    circle = {l, r};
                    break;
                }
                if (local.find({l, r}) != local.end()) {
                    circle = {l, r};
                    is_local = true;
                    break;
                } else local[{l, r}] = true;
            }
            //cout << is_local << " " << circle.first << " " << circle.second << endl;
            if(is_local){
                l = i, r = j;
                bool is_blue = true;
                while (true) {
                    if(l == circle.first && r == circle.second ){
                        if(is_blue)is_blue = false;
                        else break;
                    }
                    if(!is_blue){
                        ans[l] = 'G';
                        ans[r] = 'G';
                    }
                    dict[{l, r}] = true;
                    Point vec = Point(v[l], v[r]);
                    ld beg = vec.angle();
                    vector<vector<ld>> mb;
                    mb.push_back({beg, 0, -1});
                    for (ll z = 0; z < n; z++) {
                        if (r == z)continue;
                        vec = Point(v[r], v[z]);
                        mb.push_back({vec.angle(), vec.distance(), (ld) z});
                    }
                    sort(mb.begin(), mb.end());
                    for (ll z = 0; z < n; z++) {
                        if (mb[z][2] == -1) {
                            l = r;
                            r = (ll) mb[(z + t) % n][2];
                            break;
                        }
                    }
                    if(is_blue && ans[r] != 'G' && r == i){
                        ans[r] = 'B';
                    }
                }
            }
            else{
                l = i, r = j;
                while (true) {
                    if(l == circle.first && r == circle.second ){
                        break;
                    }
                    dict[{l, r}] = true;
                    Point vec = Point(v[l], v[r]);
                    ld beg = vec.angle();
                    vector<vector<ld>> mb;
                    mb.push_back({beg, 0, -1});
                    for (ll z = 0; z < n; z++) {
                        if (r == z)continue;
                        vec = Point(v[r], v[z]);
                        mb.push_back({vec.angle(), vec.distance(), (ld) z});
                    }
                    sort(mb.begin(), mb.end());
                    for (ll z = 0; z < n; z++) {
                        if (mb[z][2] == -1) {
                            l = r;
                            r = (ll) mb[(z + t) % n][2];
                            break;
                        }
                    }
                    if(ans[r] != 'G' && r == i){
                        ans[r] = 'B';
                    }
                }
            }
            //for(auto ii : ans)cout << ii;
            //cout << endl;
        }
    }
    for(auto i : ans)cout << i;
    return 0;
}