#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define f first
#define s second
using namespace std;
ll mod = 1e9 + 7;
ll INF = 1e6;
struct sparce{
    vector <vector<pair<ll,ll>>> sp;
    ll n, m;
    sparce(vector <ll> vv){
        m = vv.size();
        n = 20;
        sp.assign(20, vector<pair<ll,ll>>(m, {0, -1}));
        for(ll i = 0; i < m; i++)sp[0][i] = {vv[i], i};
        for(ll i = 1; (1 << i) <= m; i++){
            for(ll j = 0; j + (1 << (i - 1)) < m; j++){
                if(sp[i-1][j].f > sp[i-1][j + (1 << (i-1))].f){
                    sp[i][j] = sp[i-1][j];
                }
                else{
                    sp[i][j] = sp[i-1][j + (1 << (i-1))];
                }
            }
        }
    }
    pair<ll, ll> find(ll l, ll r){
        if(r < l)return {0, -1};
        ll len = r - l + 1;
        ll logg = log2(len);
        if(sp[logg][l].f > sp[logg][r - (1 << logg) + 1].f){
            return sp[logg][l];
        }
        else return sp[logg][r - (1 << logg) + 1];
    }
};
vector <ll> my_sol(ll n, ll q, const vector<ll>& v, vector<pair<ll, ll>> qq){
    vector <ll> anss;
    sparce sp(v);
    for(auto [a, b] : qq){
        a--;
        if(b == 1){
            anss.push_back(1);
            continue;
        }
        ll ans = 0;
        if(a - b + 1 >= 0){
            if(! (a - b >= 0 && v[a-b] < v[a])){
                pair<ll, ll> mx = sp.find(a - b + 1, a-1);
                pair <ll, ll> mxa = sp.find(a - b + 1, mx.s-1), mxb = sp.find(mx.s+1, a);
                if(v[mx.s] <= v[a])ans += b - 1;
                else if(a-b < 0 || mx.f <= v[a-b]){
                    ans += max((ll)0, mx.s - (a - b) - 1);
                    if((mx.s == 0 || mxa.f <= mxb.f || mx.s - 1 == a - b))ans++;
                }
                else if(mxa.f < v[a-b] && mxb.f < v[a-b]){
                    if(mxa.f <= mxb.f || mx.s - 1 == a - b)ans++;
                }
            }
        }
        if(a + b - 1 < n){
            if(! (a + b < n && v[a+b] < v[a])){
                pair<ll, ll> mx = sp.find(a+1, a+b-1);
                pair <ll, ll> mxa = sp.find(a, mx.s-1), mxb = sp.find(mx.s+1, a + b - 1);
                if(v[mx.s] <= v[a])ans += b - 1;
                else if(a+b >= n || mx.f <= v[a+b]){
                    ans += max((ll)0, (a + b - 1) - mx.s);
                    if((mx.s == n-1 || mxa.f >= mxb.f || mx.s + 1 == a + b))ans++;
                }
                else if(mxa.f < v[a+b] && mxb.f < v[a+b]){
                    if(mxa.f >= mxb.f || mx.s + 1 == a + b)ans++;
                }
            }
        }
        anss.push_back(ans);
    }
    return anss;
}
vector <ll> long_sol(ll n, ll q, const vector<ll>& v, vector<pair<ll, ll>> qq){
    vector <ll> anss;
    vector <vector<ll>> ans(n, vector<ll>(n, 0));
    for(ll i = 0; i < n; i++){
        ans[i][0]++;
        ll l = i-1, r = i+1;
        for(ll cnt = 1; cnt < n; cnt++){
            if(l < 0){
                ans[r][cnt]++;
                r++;
            }
            else if(r >= n){
                ans[l][cnt]++;
                l--;
            }
            else{
                if(v[l] < v[r]){
                    ans[l][cnt]++;
                    l--;
                }
                else{
                    ans[r][cnt]++;
                    r++;
                }

            }
        }
    }
    for(auto [a, b] : qq){
        anss.push_back(ans[a-1][b-1]);
    }
    return anss;
}
int main() {
    bool is_ans = true;
    if(is_ans){
        ll n, q;
        cin >> n >> q;
        vector <ll> v(n);
        for(ll i = 0; i < n; i++){
            cin >> v[i];
        }
        vector<pair<ll, ll>> qq(q);
        for(ll i = 0; i < q; i++){
            ll a,b;
            cin >> a >> b;
            qq[i] = {a, b};
        }
        vector <ll> gg = my_sol(n, q, v, qq);
        for(auto g : gg)cout << g << endl;
    }
    else{
        while(true){
            ll n = rand() % 4 + 2, q = 1;
            vector <ll> v(n);
            for(ll i = 0; i < n; i++){
                v[i] = i+1;
            }
            random_shuffle(v.begin(), v.end());
            vector <pair<ll, ll>> qq;
            ll a = rand() % n + 1, b = rand() % n + 1;
            qq.push_back({a, b});
            vector <ll> ans1 = my_sol(n, q, v, qq), ans2 = long_sol(n, q, v, qq);
            bool is = true;
            for(ll i = 0; i < q; i++){
                if(ans1[i] != ans2[i])is = false;
            }
            if(!is){
                for(auto i : v)cout << i << " ";cout << endl;
                for(auto [a, b] : qq)cout << a << " " << b << endl;
                for(auto i : ans1)cout << i << " ";cout << endl;
                for(auto i : ans2)cout << i << " "; cout << endl;
                break;
            }
        }
    }
    return 0;
}
